
var XXtea = (function () {
    function XXtea() {
    }
    XXtea.ntohl = function (src, n) {
        for (var j = 0; j < (n / 4 | 0); j++) {
            for (var i = 0; i < 2; i++) {
                var tmp = src[(j * 4) + i];
                src[(j * 4) + i] = src[(((j * 4) + 4) - i) - 1];
                src[(((j * 4) + 4) - i) - 1] = tmp;
            }
        }
    };
    XXtea.getKey = function (comm_key) {
        var temp = (comm_key.toUpperCase()).split('');
        var len = (temp.length / 2 | 0);
        var b = new Array(len);
        for (var i = 0; i < len; i++) {
            var pos = i * 2;
            b[i] = (((XXtea.charToByte(temp[pos]) << 4) | XXtea.charToByte(temp[pos + 1])) | 0);
        }
        return b;
    };
    XXtea.charToByte = function (c) {
        return ("0123456789ABCDEF".indexOf(c) | 0);
    };
    XXtea.encrypt = function (data, key) {
        return data.length === 0 ? data : XXtea.toByteArray(XXtea.encryptI(XXtea.toIntArray(data, false), XXtea.toIntArray(key, false)), false);
    };
    XXtea.decrypt = function (data, key) {
        return data.length === 0 ? data : XXtea.toByteArray(XXtea.decryptI(XXtea.toIntArray(data, false), XXtea.toIntArray(key, false)), false);
    };
    XXtea.encryptI = function (v, k) {
        var z;
        if (v != null) {
            z = true;
        }
        else {
            z = false;
        }
        var n = v.length;
        var rounds = ((52 / n | 0)) + 6;
        var sum = 0;
        var z2 = v[n - 1];
        do {
            var y = void 0;
            sum -= 1640531527;
            var e = (sum >>> 2) & 3;
            var p = 0;
            while ((p < n - 1)) {
                y = v[p + 1];
                z2 = v[p] + ((((z2 >>> 5) ^ (y << 2)) + ((y >>> 3) ^ (z2 << 4))) ^ ((sum ^ y) + (k[(p & 3) ^ e] ^ z2)));
                v[p] = z2;
                p++;
            }
            ;
            y = v[0];
            var i = n - 1;
            z2 = v[i] + ((((z2 >>> 5) ^ (y << 2)) + ((y >>> 3) ^ (z2 << 4))) ^ ((sum ^ y) + (k[(p & 3) ^ e] ^ z2)));
            v[i] = z2;
            rounds--;
        } while ((rounds > 0));
        return v;
    };
    XXtea.decryptI = function (v, k) {
        var z;
        if (v != null) {
            z = true;
        }
        else {
            z = false;
        }
        var n = v.length;
        var z2 = v[n - 1];
        var y = v[0];
        var sum = (((52 / n | 0)) + 6) * -1640531527;
        y = v[0];
        do {
            var e = (sum >>> 2) & 3;
            var p = n - 1;
            while ((p > 0)) {
                z2 = v[p - 1];
                y = v[p] - ((((z2 >>> 5) ^ (y << 2)) + ((y >>> 3) ^ (z2 << 4))) ^ ((sum ^ y) + (k[(p & 3) ^ e] ^ z2)));
                v[p] = y;
                p--;
            }
            ;
            z2 = v[n - 1];
            y = v[0] - ((((z2 >>> 5) ^ (y << 2)) + ((y >>> 3) ^ (z2 << 4))) ^ ((sum ^ y) + (k[(p & 3) ^ e] ^ z2)));
            v[0] = y;
            sum -= -1640531527;
        } while ((sum !== 0));
        return v;
    };
    XXtea.toIntArray = function (data, includeLength) {
        var n;
        var result;
        if ((data.length & 3) === 0) {
            n = data.length >>> 2;
        }
        else {
            n = (data.length >>> 2) + 1;
        }
        if (includeLength) {
            result = new Array((n + 1));
            result[n] = data.length;
        }
        else {
            result = new Array(n);
        }
        n = data.length;
        for (var i = 0; i < n; i++) {
            var i2 = i >>> 2;
            result[i2] = result[i2] | ((data[i] & 255) << ((i & 3) << 3));
        }
        return result;
    };
    XXtea.toByteArray = function (data, includeLength) {
        var n = data.length << 2;
        if (includeLength) {
            var m = data[data.length - 1];
            if (m > n) {
                return null;
            }
            n = m;
        }
        var result = new Array(n);
        for (var i = 0; i < n; i++) {
            result[i] = (((data[i >>> 2] >>> ((i & 3) << 3)) & 255) | 0);
        }
        return result;
    };
    // ld
    XXtea.byteToHex_m = function (byteAry) {//var i=0;
	  return byteAry.map(function(b) {//alert("b[" + i++ + "]=" + b);
	    return ('0' + (b & 0xFF).toString(16)).slice(-2);
	  }).join(' ');
    }
    XXtea.byteToHex = function (byteAry) {
      var res = "";//////alert("byteAry len = " + byteAry.length);
      for (var i = 0; i < byteAry.length; i++) {
      	res += " " + ('0' + (byteAry[i] & 0xFF).toString(16)).slice(-2);
      }
      return res.trim();
    }
    XXtea.byteToHexStr = function (byteAry) {
      var res = "";//////alert("byteAry len = " + byteAry.length);
      for (var i = 0; i < byteAry.length; i++) {
        res += ('0' + (byteAry[i] & 0xFF).toString(16)).slice(-2);
      }
      return res.trim();
    }
    
    return XXtea;
}());
XXtea["__class"] = "XXtea";
