﻿/**
 * 叮叮开门业务方法包装
 */


//当前所属社区信息
var _sssq;  // 社区编码
var _L_sssq = 'sssq';

var _sssqmc; // 社区名称
var _L_sssqmc = 'sssqmc';

var _sssqinfo; // 社区信息对象
var _L_sssqinfo = 'sssqinfo';

var _citymc; // 城市名称
var _L_citymc = 'citymc';
var _citydm; // 城市名称
var _L_citydm = 'citydm';

var _sssqinfolist;
var _L_sssqinfolist = 'sssqinfolist';

// 开通过权限的城市列表
var _citylist;
var _L_citylist = 'citylist';

var _xzqhData;

var _L_sssqinfolist_timeout = 'sssqinfolist_timeout';  // 过期时间，毫秒时间戳

/**
 * 社区信息初始化
 * @return {[type]} [description]
 */
function initSssqInfo(callback){

    var storeSssq = getData(_L_sssq);
    // if(storeSssq){
    //     _sssq = storeSssq;
    //     console.log('当前sssq=' + _sssq);


    //     _sssqinfolist = getData(_L_sssqinfolist);
    //     if(_sssqinfolist){
    //         _sssqinfolist = JSON.parse(_sssqinfolist);
    //     }

    //     if(_sssqinfolist && _sssqinfolist.length>0){
    //         var nSssqTimeout = getData(_L_sssqinfolist_timeout);
    //         console.log('nSssqTimeout :' + nSssqTimeout + ', currentTimestamp :' + getTimestamp());
    //         if(nSssqTimeout && getTimestamp() < nSssqTimeout){
    //             // 还未过超时时间，则不再更新记录
    //             if(callback){
    //                 callback();
    //             }
    //         }
    //     }

    // }

    console.log('取最新社区信息');
    // 从服务端更新最新所属社区信息
    updateSssqInfo(callback);
}

/**
 * 下载所属社区及权限
 *
 * 一个用户可能会存在多个社区里面 ,从服务器更新下来的社区信息列表存放本地存储对象 sssqinfolist
 * 一个用户有一个当前默认小区，当前默认小区信息存放本地存储对象 sssqinfo
 * 当前用户的默认小区的小区编码存放与本地存储对象：sssq
 */
function updateSssqInfo(callback){

    var bodyParam = {
        action: "sssq_info"
    }

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });
        console.log('updateSssqInfo: ' + JSON.stringify( ret) );

        if (ret && ret.state) {

            if( ret.clbz && ret.clbz == 'SUCCESS' && ret.data && ret.data.length>0 ) {
                // 保存对象社区信息对象列表
                //$api.setStorage('sssqinfolist', ret.data);
                _sssqinfolist = initCityinfo(ret.data);
                
                putData(_L_sssqinfolist, _sssqinfolist);
                
                //读取之前设置的默认社区代码
                //var dqsssq = $api.setStorage('sssq');
                var dqsssq = getData(_L_sssq);
                if(!dqsssq) {
                    // 当未设置默认小区时，设置第一条记录为默认小区
                    var sssqinfo = _sssqinfolist[0];

                    dqsssq = sssqinfo.xqbm;

                    saveCurrentSssqinfo(sssqinfo);

                    //$api.setStorage('sssqinfo', sssqinfo);
                    // putData(_L_sssqinfo, sssqinfo);
                    
                    // dqsssq = sssqinfo.xqbm
                    // //$api.setStorage('sssq', dqsssq);
                    // putData(_L_sssq, dqsssq);
                    // putData(_L_sssqmc, sssqinfo.xqmc);
                    
                    // _sssq = dqsssq;

                    // _citymc = sssqinfo.citymc;
                    // _citydm = sssqinfo.citydm;

                    // putData(_L_citymc, _citymc);
                    // putData(_L_citydm, _citydm);
                    
                } else {
                    // 之前有设置过默认小区的情况
                    // 检查是否当前社区在更新下来的社区列表里面的标志
                    var inSssqList = false;
                    for(var sq in _sssqinfolist){
                        var sssqinfo = _sssqinfolist[sq];
                        if(sssqinfo.xqbm==dqsssq){
                            inSssqList = true; // 存在则设为true

                            // 当前默认社区在更新下来的社区列表里面
                            // 保存当前社区信息
                            saveCurrentSssqinfo(sssqinfo);

                            // putData(_L_sssqinfo, sssqinfo);
                            // putData(_L_sssq, dqsssq);
                            // putData(_L_sssqmc, sssqinfo.xqmc);

                            // _sssq = dqsssq;

                            // _citymc = sssqinfo.citymc;
                            // _citydm = sssqinfo.citydm;

                            // putData(_L_citymc, _citymc);
                            // putData(_L_citydm, _citydm);
                        }
                    }

                    if(!inSssqList){
                        // 当前默认社区没有在更新下来的社区列表里面的情况
                        var sssqinfo = _sssqinfolist[0];

                        dqsssq = sssqinfo.xqbm;

                        saveCurrentSssqinfo(sssqinfo);

                        //$api.setStorage('sssqinfo', sssqinfo);
                        // putData(_L_sssqinfo, sssqinfo);
                        
                        // dqsssq = sssqinfo.xqbm
                        // //$api.setStorage('sssq', dqsssq);
                        // putData(_L_sssq, dqsssq);
                        // putData(_L_sssqmc, sssqinfo.xqmc);
                        
                        // _sssq = dqsssq;

                        // _citymc = sssqinfo.citymc;
                        // _citydm = sssqinfo.citydm;

                        // putData(_L_citymc, _citymc);
                        // putData(_L_citydm, _citydm);
                    }

                }

                if(_sssq){
                    console.log('更新到了最新社区信息后，取对应社区的设备信息');

                    // 社区信息每24小时更新一次
                    var nSssqTimeout = getTimestamp() + (1000 * 60 * 60 * 24);
                    putData(_L_sssqinfolist_timeout, nSssqTimeout);
                    console.log('nSssqTimeout :' + nSssqTimeout);

                    initSbxx(_sssq);
                }

            } else {

                // 清除本地对象
                removeCurrentSssq();
                //noBindHouse();

                // 重新进入社区信息初始化
                setTimeout(function () {
                    console.log('updateSssqInfo: 每隔1分钟取一次');
                    //更新绑定小区
                    updateSssqInfo();

                }, 30000);
            }
            
        } else {
            if(ret && !ret.state){

                if(ret && ret.cljg){
                    api.toast({msg: ret.cljg});
                }
            }
            if(err){
                api.toast({msg: err.msg});
            }
        }

        api.hideProgress();

        if(callback){
            callback();
        }
    })

}


function saveCurrentsssq(sssq){
    console.log('saveCurrentsssq: ' + sssq);

    if(!_sssqinfolist){
        _sssqinfolist = getData(_L_sssqinfo);
        if(_sssqinfolist){
            _sssqinfolist = JSON.parse(_sssqinfolist);
        }
    }

    if(_sssqinfolist && sssq){
        for(var sq in _sssqinfolist){
            var sssqinfo = _sssqinfolist[sq];
            if(sssqinfo.xqbm==sssq){
                saveCurrentSssqinfo(sssqinfo);
            }
        }
    }

}


/**
 * 保存当前选择的小区
 * @return {[type]} [description]
 */
function saveCurrentSssqinfo(sssqinfo){

    console.log('saveCurrentSssqinfo: ' + JSON.stringify( sssqinfo) );


    if(sssqinfo){
        //$api.setStorage('sssqinfo', sssqinfo);
        putData(_L_sssqinfo, sssqinfo);

        _sssq = sssqinfo.xqbm;

        //$api.setStorage('sssq', dqsssq);
        putData(_L_sssq, _sssq);
        putData(_L_sssqmc, sssqinfo.xqmc);
        
        _citymc = sssqinfo.citymc;
        _citydm = sssqinfo.citydm;

        putData(_L_citymc, _citymc);
        putData(_L_citydm, _citydm);

        var sssqmc = sssqinfo.xzqhmc + '-' + sssqinfo.xqmc;

        setTimeout(function () {
            api.execScript({
                name: 'root',
                script: 'updateLocationSssq("'+sssqmc+'");'
            });
        }, 100);


        // 更新开门页面的当前设备列表
        setTimeout(function () {
            api.execScript({
                name: 'root',
                frameName: 'door',
                script: 'onlyinit();'
            });
        }, 100);

        // 更新我的页面的当前小区名称
        setTimeout(function () {
            api.execScript({
                name: 'root',
                frameName: 'my',
                script: 'init();'
            });
        }, 100);

        // 更新发现页面的当前公告列表
        setTimeout(function () {
            api.execScript({
                name: 'root',
                frameName: 'main',
                script: 'init();'
            });
        }, 100);

    }

}


/**
 * 移除默认小区（权限被收回或过期）
 * @return {[type]} [description]
 */
function removeCurrentSssq(){

    console.log('removeCurrentSssq！');

    // 清除本地对象
    removeData(_L_sssq);
    removeData(_L_sssqmc);
    removeData(_L_sssqinfo);

    removeData(_L_citymc);
    removeData(_L_citydm);

}


/**
 * 初始化城市信息
 * @param  {[type]} retData [description]
 * @return {[type]}         [description]
 */
function initCityinfo(retData){

    console.log(api.frameName + ' initCityinfo > retData ：' +  JSON.stringify( retData) );

    var retSssqlist = [];

    var retCityDmlist = [];
    var retCitylist = [];


    if(retData && retData.length > 0){

        for(var idx in retData){
            var xzqhdm = retData[idx].xzqh;
            //console.log(api.frameName + ' initCityinfo > xzqh: ' + xzqhdm + ', xzqhmc: ' + getXzqhMc(xzqhdm) + ', citymc: ' + getCityMc(xzqhdm));

            retData[idx].xzqhmc = getXzqhMc(xzqhdm);

            var tempCityinfo = getCityInfo(xzqhdm);

            if(tempCityinfo){
                retData[idx].citymc = tempCityinfo.jc;
                retData[idx].citydm = xzqhdm.substr(0,4).concat('00');
                retData[idx].cityinfo = tempCityinfo;
            }

            retSssqlist.push(retData[idx]);

            if(retCityDmlist.indexOf(tempCityinfo.dm) == -1) {
                retCityDmlist.push(tempCityinfo.dm);
                retCitylist.push(tempCityinfo);
            }
        }
    }

    _citylist = retCitylist; 
    putData(_L_citylist, _citylist);

    console.log(api.frameName + ' initCityinfo > _citylist ：' +  JSON.stringify( _citylist) );
    //console.log(api.frameName + ' initCityinfo > retSssqlist ：' +  JSON.stringify( retSssqlist) );

    return retSssqlist;
}


/**
 * [initXzqhData 初始化行政区划数据]
 * @return {[type]} [description]
 */
function initXzqhData(){
    if(!_xzqhData) {
        var tempData = api.readFile({
            sync: true,
            path: 'widget://res/data/xzqh.json'
        });

        if(tempData){
            _xzqhData = JSON.parse(tempData);
            //console.log(api.frameName + ' getXzqhMc > init initXzqhData ：' +  JSON.stringify(_xzqhData) );
        }
    }
}


/**
 * [getXzqhMc 获取行政区划名称]
 * @return {[type]} [description]
 */
function getXzqhMc(xzqhdm){

    console.log(api.frameName + ' getXzqhMc > xzqhdm ：' +  xzqhdm );

    initXzqhData();

    if(xzqhdm && _xzqhData && _xzqhData.xzqh){

        for(var idx in _xzqhData.xzqh){
            if(_xzqhData.xzqh[idx].dm==xzqhdm){
                return _xzqhData.xzqh[idx].mc;
            }
        }
    }

    return "";
}



/**
 * [getXzqhMc 获取行政区划对应的市级城市名称]
 * @return {[type]} [description]
 */
function getCityInfo(xzqhdm){

    console.log(api.frameName + ' getCityMc > xzqhdm ：' +  xzqhdm );

    initXzqhData();

    if(xzqhdm && _xzqhData && _xzqhData.city){

        var citydm = xzqhdm.substr(0,4).concat('00');
        //console.log(api.frameName + ' getCityMc > citydm ：' +  citydm );

        for(var idx in _xzqhData.city){
            if(_xzqhData.city[idx].dm == citydm){
                return _xzqhData.city[idx];
            }
        }
    }

    return "";
}


function saveCityInfo(cityinfo){

    if(cityinfo && cityinfo.dm && cityinfo.jc) {
        _L_citydm = cityinfo.dm;
        _L_citymc = cityinfo.jc;
        putData(_L_citymc, _citymc);
        putData(_L_citydm, _citydm);
    }

}



/************** 设备信息相关 **************************/

var _sbxxList;
var _L_sbxxList = 'sbxxlist';
var _L_sbxxList_timeout = 'sbxxlist_timeout';  // 过期时间，毫秒时间戳


function initSbxx(dqsssq,callback){

    
    _sssq = getData(_L_sssq);

    if(!dqsssq){
        dqsssq = getData(_L_sssq);
    }
    
    console.log(api.frameName + ' ddkmservice initSbxx > dqsssq ：' +  dqsssq +', _sssq ：' +  _sssq );

    if(!_sssq || !dqsssq){
        return; // 没有社区记录？
    }

    _L_sbxxList = 'sbxxlist' + _sssq;
    _L_sbxxList_timeout = 'sbxxlist_timeout' + _sssq;

    _sbxxList = getData(_L_sbxxList);
    if(_sbxxList){
        _sbxxList = JSON.parse(_sbxxList);
        // for(var sIdx in _sbxxList){
        //     if(_sbxxList[sIdx].sb_sssq != dqsssq){
        //         console.log(api.frameName + '> initSbxx 1 : 当前所属社区与本地设备的社区不匹配，重新更新设备信息!  sssq=' + dqsssq + ', sbxx.sb_sssq=' + _sbxxList[sIdx].sb_sssq);
        //         removeData(_L_sbxxList);

        //         // 重新初始化
        //         initSbxx(dqsssq,callback);
        //     }
        // }
    }

    if(_sbxxList && _sbxxList.length>0){
        var nSbxxTimeout = getData(_L_sbxxList_timeout);
        console.log('sbxxList_timeout :' + nSbxxTimeout + ', currentTimestamp :' + getTimestamp());
        if(nSbxxTimeout && getTimestamp() < nSbxxTimeout){
            // 还未过超时时间，则不再更新记录
            
            // 权限有效期判断
            _sbxxList = sbxxYxq(_sbxxList);
            // 保存最新纪录
            putData(_L_sbxxList,_sbxxList);


            if(callback){
                callback(_sbxxList);
            }

            return; // 退出初始化
        }
    }
    
    // 更新设备信息
    updateSbxxList(dqsssq,callback);
}


/**
 * 从服务器获取当前用户设备列表
 * @return {[type]} [description]
 */
function updateSbxxList(dqsssq,callback){

    var bodyParam = {
        action: "sbxx_info",
        req: {
            sssq: dqsssq
        }
    }

    console.log(api.frameName + '> updateSbxxList : bodyParam' + JSON.stringify(bodyParam) );

    // Post
    ajaxPost(bodyParam, function (ret, err) {
        console.log(api.frameName + '> updateSbxxList ret: ' + JSON.stringify( ret) );

        if (ret && ret.state) {

            _L_sbxxList = 'sbxxlist' + dqsssq;
            _L_sbxxList_timeout = 'sbxxlist_timeout' + dqsssq;

            if( ret.data && ret.data.length > 0 ) {

                _sbxxList = ret.data;

                for(var sIdx in _sbxxList){
                    var tempSbcs = _sbxxList[sIdx].sbcs;
                    if(tempSbcs){
                        tempSbcs = JSON.parse(tempSbcs);
                        if(tempSbcs && tempSbcs.devKey){
                            _sbxxList[sIdx].devKey = tempSbcs.devKey;
                        }
                        if(tempSbcs && tempSbcs.keyboard){
                            _sbxxList[sIdx].keyboard = tempSbcs.keyboard;
                        } else {
                            _sbxxList[sIdx].keyboard = '1';
                        }
                    }
                }

                // 权限有效期判断
                _sbxxList = sbxxYxq(_sbxxList);

                putData(_L_sbxxList, _sbxxList);

                var nSbxxTimeout = getTimestamp() + (1000 * 60 * 5);
                putData(_L_sbxxList_timeout, nSbxxTimeout);
                console.log('sbxxList_timeout :' + nSbxxTimeout);

                if(callback){
                    callback(_sbxxList);
                }

            } else {
                //取不到设备信息记录，没有授权、授权过期或者授权被取消
                removeData(_L_sbxxList);
                removeData(_L_sbxxList_timeout);
                
                
                // 重新进入社区信息初始化
                setTimeout(function () {
                    console.log('updateSbxxList: 每隔1分钟取一次');
                    //更新设备信息
                    updateSbxxList(dqsssq,callback);

                }, 30000);
            }

        } else {

            if(ret && !ret.state){
                if(ret.cljg){
                    api.toast({msg: ret.cljg})
                }
            }
            if(err){
                api.toast({msg: err.msg})
            }


            if(callback){
                callback(_sbxxList);
            }

        }
        api.hideProgress();
    })
}


/**
 * [sbxxYxq 设备权限有效期判断]
 * @param  {[type]} inSbxxlist [description]
 * @return {[type]}            [description]
 */
function sbxxYxq(inSbxxlist){
    var retSbxxist = [];

    if(inSbxxlist && inSbxxlist.length>0){

        for(var sIdx in inSbxxlist){
            var tempSbxx = inSbxxlist[sIdx];
            var yxq = true;

            //console.log('sbxxYxq> tempSbxx: ' + JSON.stringify( tempSbxx) );

            if(tempSbxx && tempSbxx.yxqjz){
                var tempJzsj = inSbxxlist[sIdx].yxqjz;
                if(tempJzsj.length == 8){
                    tempJzsj = tempJzsj + '235959';
                }

                if(tempJzsj.length == 14){
                    var tempYXQJZ = tempJzsj.substr(0,4) + '/' + tempJzsj.substr(4,2) + '/' + tempJzsj.substr(6,2) + ' ' + tempJzsj.substr(8,2)+ ':' + tempJzsj.substr(10,2) + ':' + tempJzsj.substr(12,2);  
                    //console.log('sbxxYxq>  tempYXQJZ: ' + tempYXQJZ );

                    var dateJZSJ = new Date(tempYXQJZ);
                    var currdate = new Date();

                    if((currdate.getTime() - dateJZSJ.getTime()) > 0){
                        yxq = false;
                        console.log('sbxxYxq>  过期权限记录 '  );
                    } //else {
                        //console.log('sbxxYxq>  有效权限记录 '  );
                    //}
                }

            }

            // 有效的权限记录
            if(yxq){
                retSbxxist.push(tempSbxx);
            }

        }
    }

    return retSbxxist;
}



/************** 收藏相关 **************************/
var _favList; // 收藏列表
var _L_favList='favList'; // 收藏列表本地保存对象名


/**
 * 初始化收藏列表
 * @return {[type]} [description]
 */
function initFav(callback){
        // 收藏从本地存储取
    var storeFavs = $api.getStorage(_L_favList);
    if(storeFavs){
        _favList = storeFavs;
        if(callback){
            callback(_favList);
        }
    } else {
        // 当第一次使用的，服务器端下载
        loadFav(callback);
    }
}


/**
 * 从服务端下载收藏记录
 * @param  {Function} callback [description]
 * @return {[type]}            [description]
 */
function loadFav(callback){

    var bodyParam = {
        action: "fav_query"
    }

    console.log(api.frameName + '> loadFav : bodyParam' + JSON.stringify(bodyParam) );

    // Post
    ajaxPost(bodyParam, function (ret, err) {
        console.log('queryFav ret: ' + JSON.stringify( ret) );

        if (ret && ret.state) {
            if( ret.data && ret.data.length > 0 ) {
                var favs = ret.data;

                //遍历json数组,设置不同类型收藏的类型图片
                for(var xq in favs){
                    if(favs[xq].sclx == '01'){

                        favs[xq].typename='社区公告';

                        var scnr = favs[xq].scnr;
                        if(scnr){
                            scnr = JSON.parse(scnr);

                            if(scnr.lx=='1'){
                                favs[xq].typeimg = '../image/notice_lx_1.png';
                            }
                            if(scnr.lx=='2'){
                                favs[xq].typeimg = '../image/notice_lx_2.png';
                            }

                            favs[xq].time = formatTime12(scnr.fbsj);
                            favs[xq].title = scnr.bt;   
                            favs[xq].destid = scnr.ggid;   
                        }
                    } 

                    if(!favs[xq].typeimg){
                        favs[xq].typeimg = '../image/demo1.png';
                    }
                }

                _favList = favs;
            } else {
                // 服务端收藏列表为空
                _favList = [];
            }

            // 保存到本地
            $api.setStorage(_L_favList,_favList);
            if(callback){
                callback(_favList);
            }  

        } else {
            if(ret && !ret.state){
                if(ret.cljg){
                    api.toast({msg: ret.cljg})
                }
            }
            if(err){
                api.toast({msg: err.msg});
            }
        }
        api.hideProgress();
    });

}

/**
 * 添加收藏
 * @param {[type]}   sclx     [收藏类型]
 * @param {[type]}   scnrObj  [收藏内容 JSON ]
 * @param {Function} callback [回调方法]
 */
function addFav(sclx,scnrObj,callback){
    console.log(api.frameName + '> addFav: sclx=' + sclx + ', scnrObj=' + JSON.stringify(scnrObj));

    if(!sclx || !scnrObj){
        return;
    }

    var bodyParam = {
        action: "fav_add",
        req: {
            sclx: sclx,
            scnr: JSON.stringify(scnrObj)
        }
    }

    console.log(api.frameName + '> addFav : bodyParam' + JSON.stringify(bodyParam) );

    // Post
    ajaxPost(bodyParam, function (ret, err) {
        console.log('addFav ret: ' + JSON.stringify( ret) );

        if (ret && ret.state) {

            // 保存到本地收藏列表
            var scObj = {
                scid: ret.data.scid,
                sclx: '01',
                scsj: getDateTime14(),
                scnr: scnrObj,
                time: formatTime12(_noticeInfo.fbsj),
                title: _noticeInfo.bt,
                destid: _noticeInfo.ggid,
                typename: '社区公告',
                typeimg: '../image/notice_lx_'+_noticeInfo.lx+'.png' 
            }

            if(!_favList){
                _favList = $api.getStorage('favList');    
            }
            if(_favList){
                _favList.unshift(scObj);
                $api.setStorage(_L_favList,_favList);
            }

            //回调
            callback(scObj);

        } else {
            if(ret && !ret.state){
                if(ret.cljg){
                    api.toast({msg: ret.cljg})
                }
            }
            if(err){
                api.toast({msg: err.msg});
            }
        }
        api.hideProgress();
    });

}


/**
 * 删除收藏
 * @param  {[type]}   favId    [description]
 * @param  {Function} callback [description]
 * @return {[type]}            [description]
 */
function delFav(favId,callback){
    console.log(api.frameName + '> delFav: favId=' + favId);
    if(!favId){
        return;
    }

    var bodyParam = {
        action: "fav_del",
        req: {
            scid: favId
        }
    }

    console.log(api.frameName + '> delFav : bodyParam' + JSON.stringify(bodyParam) );

    // Post
    ajaxPost(bodyParam, function (ret, err) {
        console.log('delFav ret: ' + JSON.stringify( ret) );

        if (ret && ret.state) {

            if(!_favList){
                _favList = $api.getStorage('favList');    
            }
            
            var ggid;

            for(var idx in _favList){
                if(_favList[idx].scid == favId){
                	ggid = _favList[idx].destid;
                    _favList.splice(idx,1);
                    $api.setStorage(_L_favList,_favList);
                }
            }

            if(callback){
                callback(favId,ggid);
            }

        } else {
            if(ret && !ret.state){
                if(ret.cljg){
                    api.toast({msg: ret.cljg})
                }
            }
            if(err){
                api.toast({msg: err.msg});
            }
        }
        api.hideProgress();
    });

}
