var _initOK = false;


apiready = function () {
    init();  // TODO 需要缓存
};


// 初始化，下载社区列表
function init() {
    console.log('doorDev_frm init');

    // TODO 测试数据，正式数据要从服务器取 
    //var favs = [{favid:'11001',type: '社区公告', destid: '1235552', time:'2017-05-10 17:09',img:'../image/hongbao.png',title: '关于幸福小区2017年度物业费优惠活动的通知'},{favid:'11001',type: '社区公告', destid: '1235553', time:'2017-05-09 17:09',img:'../image/hongbao.png',title: '关于幸福小区2017春季老年人活动的通知'}];
    var sbxxlist = api.pageParam.sbxxlist;

    if(sbxxlist){
        console.log('doorDev_frm init sbxxlist：' + JSON.stringify(sbxxlist));

	    //alert(JSON.stringify(msgs));
	    //渲染页面
	    var content = $api.byId('content');
	    var tpl = $api.byId('template').text;
	    var tempFn = doT.template(tpl);
	    content.innerHTML = tempFn(sbxxlist);
	    // alert(content.innerHTML); 	
        
        api.parseTapmode(); 
    }

    _initOK = true;
}


/**
 * 开门
 * @param  {[type]} sbsn    [description]
 * @param  {[type]} eKey    [description]
 * @param  {[type]} devType [description]
 * @return {[type]}         [description]
 */
function openDoor(sbsn,eKey,devType){
    console.log(api.frameName + '> openDoor : sbsn=' + sbsn + ', eKey=' + eKey + ', devType=' + devType );

    var exeCmd = 'openDoorBySbsn(\''+sbsn+'\');';

    api.execScript({
        name: 'root',
        frameName: 'door',
        script: exeCmd
    });

    setTimeout(function(){
        api.closeWin();
    },100);

}

/**
 * 显示设备列表中在线的设备状态
 * @param  {[type]} devlist [description]
 * @return {[type]}         [description]
 */
function updateDevStatus(devlist){
    //console.log(api.frameName + '> updateDevStatus : devlist=' + devlist);

    if(!_initOK){
        return;
    }

    var onlineDevList = devlist;
    if(onlineDevList){
        onlineDevList = JSON.parse(onlineDevList);

        // 清除原先的状态
        var sbxxlist = api.pageParam.sbxxlist;
        if(sbxxlist){
            for(var sbidx in sbxxlist){
                var elDevStatus = $api.byId('devstatus-' + sbxxlist[sbidx].sbsn);
                if(elDevStatus){
                    $api.text(elDevStatus,'');
                }

                var elDevicon = $api.byId('devicon-' + sbxxlist[sbidx].sbsn);
                if(elDevicon){
                    $api.removeCls(elDevicon, 'aui-text-success');
                }
            }      
        }

        // 更新最新状态
        for(var idx in onlineDevList){
            if(onlineDevList[idx].sbsn){
                var elDevStatus = $api.byId('devstatus-' + onlineDevList[idx].sbsn);
                if(elDevStatus){
                    $api.text(elDevStatus, onlineDevList[idx].rssi + ' 可用');
                }

                var elDevicon = $api.byId('devicon-' + onlineDevList[idx].sbsn);
                if(elDevicon){
                    $api.addCls(elDevicon, 'aui-text-success');
                }
            }
        }
    }




}
