﻿//previous page id, current page id
var prevPid = '', curPid = '';
//save opened frame name
var frameArr = [];


apiready = function(){
    api.parseTapmode();

    //api.alert({msg:'index apiready! winName:' + api.winName});
    //api.alert({msg:'islogined: ' + islogined()});
    
    //var token = $api.getStorage('token');
    if(!islogined()){
        openlogin();
    } else {
        init();
    }
    
};


// 退回到上一个tab页面
function backTab(){
    if(prevPid){
        openTab(prevPid,_sssq);
    }
}


//frame whether open
function isOpened(frmName){
    var i = 0, len = frameArr.length;
    var mark = false;
    for(i; i<len; i++){
        if(frameArr[i] === frmName){
            mark = true;
            return mark;
        }
    }
    return mark;
}

//toggle header
function showHeader(type){
    console.log('showHeader type: ' + type);
    if(!type){return;}

    var header = $api.dom('.aui-show');
    if(header){
        $api.removeCls(header,'aui-show');
    }
    var thisHeader = $api.byId('aui-header-'+type);
    if(thisHeader){
        $api.addCls(thisHeader,'aui-show');
    }
}


//open tab
function openTab(type,dqsssq){
    console.log('openTab>  type=' + type + ', dqsssq=' + dqsssq + ', _sssq=' + _sssq);

    // 登录判断
    var token = $api.getStorage('token');
    if(!token){
        openlogin();
        return;
    }

    if(!dqsssq){
        if(!_sssq){
            _sssq = getData(_L_sssq);
        }
        dqsssq = _sssq;
    }

    type = type || 'main';

    // 开门页面一定要绑定房屋后才显示
    if(type == 'door'){
        if(!_sssq){
            noBindHouse();
            return;
        }
    }

    showHeader(type);

    var header = $api.byId('aui-header');

    console.log('headerPos: 1 ' + JSON.stringify($api.offset(header)));

    $api.fixStatusBar(header);

    // var nav = $api.byId('nav');
    // var navPos = $api.offset(nav);
    // var header = $api.byId('header');
    // var headerPos = $api.offset(header);
    // var height = api.winHeight - navPos.h - headerPos.h;
     
    var header = $api.byId('aui-header');
    var headerPos = $api.offset(header);

    console.log('headerPos: 2 ' + JSON.stringify(headerPos));

    var width = api.winWidth;
    var height = api.winHeight - 50 - headerPos.h;


    // var actTab = $api.dom('#nav .active');
    // $api.removeCls(actTab,'active');
    // var thisTab = $api.dom('#nav .'+ type);
    // thisTab = thisTab.parentNode;
    // $api.addCls(thisTab,'active');

    //record page id
    prevPid = curPid;
    curPid = type;
    if(prevPid !== curPid){

        // alert(type+':'+isOpened(type));
    
        if(isOpened(type)){
            api.setFrameAttr({
                name: type,
                hidden: false
            });

            // 显示开门栏时，从服务器下载一下数据
            // todo:应该不是每次都下载，要加个时间判断
            if(type=='door'){
                api.execScript({
                    name: 'root',
                    frameName: 'door',
                    script: 'init();'
                });
            }

        }else{
            api.openFrame({
                name: type,
                url: 'html/'+ type +'.html',
                bounces: true,
                opaque: true,
                vScrollBarEnabled: false,
                pageParam:{ headerHeight: headerPos.h,sssq: dqsssq},
                rect: {
                    x: 0,
                    y: headerPos.h,
                    w: width,
                    h: height
                }
            });
        }

        if(prevPid){
            api.setFrameAttr({
                name: prevPid,
                hidden: true
            });

            // 从开门页面切换到其它页面，需要停止蓝牙设备
            if(prevPid == 'door'){
                console.log('离开开门页面，停止蓝牙扫描！')
                api.execScript({
                    name: 'root',
                    frameName: 'door',
                    script: 'ble_stop();'
                });
            }
        }

        if(!isOpened(type)){
            //save frame name
            frameArr.push(type);
        }
        
    }
    
}


function scan(){

    var FNScanner = api.require('FNScanner');
    FNScanner.openScanner({
        autorotation: true
    }, function(ret, err) {
        if (ret) {
            console.log('scan>  ret: ' + JSON.stringify(ret));
            //alert(JSON.stringify(ret));
            var resUrl = ret.content;

            if(!resUrl){return;}

            //alert('扫到的内容：'+resUrl);
            // if(resUrl.substr(0,4)=='http'){
            // };

            api.openApp({
                iosUrl: resUrl,
                androidPkg: 'android.intent.action.VIEW',
                mimeType: 'text/html',
                uri: resUrl
            }, function (ret, err) {
            });

        } else {
            alert(JSON.stringify(err));
        }
    });

}




function opentabbar(){

    var NVTabBar = api.require('NVTabBar');
    NVTabBar.open({
        styles: {
            bg: '#fff', 
            //bg: 'widget://res/NVTabBar/NVTabBar_bg_white.png',
            h: 50,
            dividingLine: {
                width: 1,
                color: '#c9c9c9'
            },
            badge: {
                bgColor: '#FF0033',
                numColor: '#fff',
                size: 6.0
            }
        },
        items: [{
            w: api.winWidth / 3.0,
            bg: {
                marginB: -5.0,
                image: 'rgba(0,0,0,0)'
            },
            iconRect: {
                w: 25.0,
                h: 25.0,
            },
            icon: {
                normal: 'widget://res/NVTabBar/icon_home_0.png',
                highlight: 'widget://res/NVTabBar/icon_home_1.png',
                selected: 'widget://res/NVTabBar/icon_home_2.png'
            },
            title: {
                text: '发现',
                size: 12.0,
                normal: '#757575',
                selected: '#ff6000',
                marginB: 2.0
            }
        }, {
            w: api.winWidth / 3.0,
            bg: {
                marginB: -5.0,
                image: 'rgba(0,0,0,0)'
            },
            iconRect: {
                w: 25.0,
                h: 25.0,
            },
            icon: {
                normal: 'widget://res/NVTabBar/icon_door_0.png',
                highlight: 'widget://res/NVTabBar/icon_door_1.png',
                selected: 'widget://res/NVTabBar/icon_door_2.png'
            },
            title: {
                text: '开门',
                size: 12.0,
                normal: '#757575',
                selected: '#ff6000',
                marginB: 2.0
            }
        }, {
            w: api.winWidth / 3.0,
            bg: {
                marginB: -5.0,
                image: 'rgba(0,0,0,0)'
            },
            iconRect: {
                w: 25.0,
                h: 25.0,
            },
            icon: {
                normal: 'widget://res/NVTabBar/icon_my_0.png',
                highlight: 'widget://res/NVTabBar/icon_my_1.png',
                selected: 'widget://res/NVTabBar/icon_my_2.png'
            },
            title: {
                text: '我的',
                size: 12.0,
                normal: '#757575',
                selected: '#ff6000',
                marginB: 2.0
            }
        }],
        selectedIndex: 0
    }, function(ret, err) {
        if (ret) {
            //alert(JSON.stringify(ret));

            //
            if(ret.index === 0) {
                openTab('main', _sssq);
            }

            if(ret.index === 1) {
                openTab('door', _sssq);
            }

            if(ret.index === 2) {
                openTab('my', _sssq);
            }

            NVTabBar.bringToFront();
        }
    });

}


function islogined(){
    var token = $api.getStorage('token');
    if(!token){
        return false;
    } else {
        return true;
    }
}

function openlogin(){
    api.openWin({
        name: 'userLogin',
        url: './html/userLogin.html',
        opaque: true,
        vScrollBarEnabled: false,
        slidBackEnabled: false,
        bounces: false,
        reload: false
    });
}


// 推送消息侦听
function setPushListener(){
    var push = api.require('push');
    push.setListener(function( ret, err ){
         if( ret ){
            // api.alert({
            //     title: 'PushListener',
            //     msg: ret
            // });
            console.log('PushListener: ' + JSON.stringify( ret) );
         }else{
            alert( JSON.stringify( err) );
         }
    });
}


// 绑定当前用户
function bindPush(){
    var uid=$api.getStorage('uid');
    console.log('bindPush: uid=' + uid);

    var push = api.require('push');
    push.bind({
        userName: uid,
        userId: uid
    }, function(ret, err){
        if( ret ){
            //alert('bind: ' + JSON.stringify( ret) );
            console.log('bindPush ret: ' + JSON.stringify( ret) );
        }else{
            alert( JSON.stringify( err) );
        }
    });
}


// 点击通知栏打开目标应用侦听
function noticeClickedListener(){
    api.addEventListener({
        name:'noticeclicked'
    },function(ret,err){
        console.log('noticeclicked < ret: ' + JSON.stringify(ret) );
        if(ret.type == 0){
            if(api.systemType == 'ios'){
                    var pushContent =  ret.value;
                    openMsgPush(pushContent);
            }else{
                    var pushValue =  JSON.parse(ret.data);
                    if(pushValue && pushValue.length>0){
                        var pushContent =  pushValue.pop();
                    }
            }
        }                        
    });
}

/**
 * 智能增量更新(云修复)
 * @return {[type]} [description]
 */
function smartUpdateListener(){
    api.addEventListener({
        name:'smartupdatefinish'
    }, function(ret, err){        
        console.log('云修复完成! ' + JSON.stringify(ret));
        api.rebootApp();// 重新加载app
    });
}


/**
 * 推送消息处理
 * @param  {[type]} pushContent [description]
 * @return {[type]}             [description]
 */
function openMsgPush(pushContent){
    console.log('openMsgPush > pushContent: ' + JSON.stringify(pushContent) );
    //alert(JSON.stringify(pushContent) );
}


function init(uid){
    // 设置系统状态栏颜色
    api.setStatusBarStyle({
            style: 'dark'
    });

    setPushListener();

    noticeClickedListener();

    smartUpdateListener();

    setTimeout(function () {
        bindPush();
    }, 500);
            
    //更新绑定小区
    initSssqInfo(showMainPage);
}

/**
 * [showMainPage 显示主界面]
 * @return {[type]} [description]
 */
function showMainPage(){

    //初始化底部导航栏
    opentabbar();

    // 打开主页面
    openTab('main',_sssq);

    // 重新初始化“我的”页面
    if(isOpened('my')){
        setTimeout(function () {
            api.execScript({
                name: 'root',
                frameName: 'my',
                script: 'getUserInfo();'
            });
        }, 100);
    }

    // 延时做数据初始化
    setTimeout(function () {

        //初始化收藏列表
        initFav();

    }, 200);
}


function locateSelect(){

    //alert('目前开通城市仅为杭州，其它城市将陆续推出');
    console.log('locateSelect! ');

    getLocation();

    api.openWin({
        name: 'locationSelect',
        url: './html/locationSelect.html',
        opaque: true,
        vScrollBarEnabled:false
    });

}


/** 更新首页面的当前小区名称 */
function updateLocationSssq(sssqmc){
    var elsssq = $api.byId('locationsssq');
    if(elsssq && sssqmc){
        $api.text(elsssq,sssqmc);
    }
}



function doSearch(keywords){
    api.showProgress({
        title: '正在搜索...',
        modal: true
    });

    setTimeout(function () {
        api.hideProgress();
    }, 3000);

}

// function showPopup(){
//     api.execScript({
//         name: 'root',
//         frameName: 'main',
//         script: 'showPopup("top-right");'
//     });
// }

function getLocation(){
    console.log('getLocation  开始获取当前位置！');

    api.getLocation(function(ret, err) {
        if (ret && ret.status) {
            //获取位置信息成功
            console.log('getLocation  ret: ' + JSON.stringify(ret));

        } else {
            console.log('getLocation  err: ' + JSON.stringify(err));
        }
    });
}


