﻿

apiready = function(){

    api.parseTapmode();

    init();
};


function init(){

    _citydm = getData(_L_citydm);
    _citymc = getData(_L_citymc);
    _sssq = getData(_L_sssq);
    _sssqinfolist = getData(_L_sssqinfolist);
    if(_sssqinfolist){
        _sssqinfolist = JSON.parse(_sssqinfolist);
    }
    
    console.log(' _citydm : ' + _citydm + ', _citymc : ' + _citymc+ ', _sssq : ' + _sssq);
    console.log(' _sssqinfolist : ' + JSON.stringify( _sssqinfolist) );

    locateSelect();  
}


function locateSelect(){

    var contactData = [];

    var storeSssq = getData(_L_sssq);

    if(_sssqinfolist && _sssqinfolist.length > 0 && _citydm){
        for( var idx in _sssqinfolist ){
            if(_sssqinfolist[idx].citydm == _citydm){

                var contact = {
                    sssq: _sssqinfolist[idx].xqbm,
                    name: _sssqinfolist[idx].xqmc,
                    customerTypes: _sssqinfolist[idx].xzqhmc,
                    sssqinfo: _sssqinfolist[idx]
                };

                if(storeSssq && storeSssq == contact.sssq){
                    contact.name=contact.name + '(当前)';
                }

                contactData.push(contact);
            }

        }


        // 更改标题
        api.execScript({
            name: 'locationSelect',
            script: 'changeCity("'+_citymc+'");'
        });

    }


    var UIListCard = api.require('UIListCard');

    UIListCard.open({
                rect : {
                    x : 0,
                    y : 0,
                    w : api.frameWidth,
                    h : api.frameHeight
                },
                contacts : contactData,
                fixedOn : api.frameName
            }, function(ret) {
                if (ret) {
                    console.log(' UIListCard  ret : ' + JSON.stringify( ret) );

                    if(ret.eventType == 'click' && ret.contact  && ret.contact.sssq && ret.contact.sssqinfo){

                        if(_sssq != ret.contact.sssq) {
                            saveCurrentSssqinfo(ret.contact.sssqinfo);
                        }

                        // 关闭当前窗口
                        setTimeout(function () {
                            api.execScript({
                                name: 'locationSelect',
                                script: 'closewin();'
                            });
                        }, 200);

                    }

                }
            });

}

