var _userinfo;
var _nickname;
var _txurl;

function modifyNick(nickname) {
    nickname = nickname || '';
    api.openWin({
        name: 'modifyNick',
        url: 'modifyNick.html',
        opaque: true,
        pageParam: {
            nickname: _nickname
        },
        vScrollBarEnabled: false
    });
}

function modifyTxUrl(txurl) {
    txurl = txurl || '';
    api.openWin({
        name: 'modifyTxUrl',
        url: 'modifyTxUrl.html',
        opaque: true,
        pageParam: {
            txurl: _txurl
        },
        vScrollBarEnabled: false
    });
}

function updateNc(nickname){
    if(nickname){
        $api.text($api.byId('nc'),nickname);
        _nickname = nickname;
    }
}

function updateTxUrl(txurl){
    if(txurl){
        //$api.text($api.byId('txurl'),txurl);
        $api.byId('txurl').src = txurl;
        _txurl = txurl;
    }
}

function init(initUserInfo) {

    console.log(api.frameName + ', init');

    var userinfo;

    if(initUserInfo){
        userinfo = initUserInfo;
    } else {
        userinfo = $api.getStorage('userinfo');
    }

    showUserInfo(userinfo);
}

function showUserInfo(userInfo){
    console.log(api.frameName + ', showUserInfo: ' + JSON.stringify(userInfo));

    if(userInfo){
        _userinfo = userInfo;
        _nickname = userInfo.nc;
        _txurl = userInfo.cachedTxUrl;

         //渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
        content.innerHTML = tempFn(userInfo);
        // alert(content.innerHTML);       
    }
}

apiready = function () {
    api.parseTapmode();

    init(api.pageParam.userinfo);  
};