var _scsj;
var _msgs;


function updateMsg(){

    console.log(api.frameName + '> updateMsg() ');

    var bodyParam = {
        action: "vistor_info",
        req: {
            type: '1001',
            scsj: _scsj
        }
    }

    ajaxPost(bodyParam, function (ret, err) {
        console.log('ajaxPost: ' + JSON.stringify(ret) );
        if (ret && ret.state) {
            if( ret.data && ret.data.length > 0 ) {
                var msglist = ret.data;

                for(var idx in msglist){
                    msglist[idx].bt = '访客授权';
                    msglist[idx].fbsj = formatTime14(msglist[idx].scsj);
                    msglist[idx].nr = '访客姓名：' + msglist[idx].fkxm + ', 来访事由：' + msglist[idx].fksy + ', 联系电话：' + msglist[idx].fklxdh + ', 授权设备：' + msglist[idx].sbmc + ', 授权密码：' + msglist[idx].lsmm.substr(0,1) + '****' + msglist[idx].lsmm.substr(7,1) + ', 有效期截止时间：' + formatTime12(msglist[idx].jzsj)  + ', 密码发送方式：' + (msglist[idx].mmfsfs=='1'?'短信':'微信'); 
                }

                // 合并消息数据
                mergeMsg(msglist);
            }
            
        } else {
            if(ret && !ret.state){
                api.toast({msg: ret.cljg})
                // api.alert({
                //     msg: ret.cljg
                // });
            }
            if(err){
                api.alert({
                    msg: err.msg
                });
            }
        }

        api.hideProgress();

        // 显示消息记录
        showMsg(_msgs);
    })

}

// 合并消息记录
function mergeMsg(msgList){
    console.log(api.frameName + '> msgList()  msgList:' + JSON.stringify(msgList));
    if(msgList && msgList.length>0){
        if(_msgs){
            _msgs.unshift.apply(_msgs,msgList);
        } else {
            _msgs = msgList;
        }

        _scsj = _msgs[0].scsj;
        putData('myVisitor_scsj',_scsj);
        putData('myVisitor_msgs',_msgs);

        console.log(api.frameName + '> msgList()  myVisitor_msgs:' + JSON.stringify(_msgs));
    }
}

// 初始化，下载社区列表
function init() {
    console.log(api.frameName + '> init');

    _scsj = getData('myVisitor_scsj');
    _msgs = getData('myVisitor_msgs');

    if(_msgs){
       _msgs = JSON.parse(_msgs); 
    }

    // 从服务端更新最新数据
    updateMsg();

    //var msgs = [{bt:'登录提醒',fbsj: '2017-05-11 17:09', nr: '您的帐号于2017-5-11 11:22:33在香港登录，请注意账户安全'},{bt:'登录提醒',fbsj: '2017-05-10 17:09', nr: '您的帐号于2017-5-10 11:22:33在香港登录，请注意账户安全'},{bt:'登录提醒',fbsj: '2017-05-09 17:09', nr: '您的帐号于2017-5-09 11:22:33在香港登录，请注意账户安全'}];
    //showMsg(msgs);
    //
    // var a = [4,3,2,1];
    // var b = [6,5,4,1];

    // a.unshift.apply(a,b);

    // console.log(api.frameName + '> init  a:' + JSON.stringify(a));

}


function showMsg(msgs){
    if(msgs){
        console.log(api.frameName + '> showMsg: ' + JSON.stringify(msgs));
        //alert(JSON.stringify(msgs));
        //渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
        content.innerHTML = tempFn(msgs);
        // alert(content.innerHTML);  
        
        api.parseTapmode();  
    }
}


apiready = function () {
    //pull to refresh
    api.setRefreshHeaderInfo({
        visible: true,
        // loadingImgae: 'wgt://image/refresh-white.png',
        bgColor: '#f2f2f2',
        textColor: '#4d4d4d',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true
    }, function (ret, err) {
        updateMsg();
        api.parseTapmode();
        //api.parseTapmode();
        api.refreshHeaderLoadDone();
    });



    init();  // TODO 需要缓存

    api.parseTapmode();
};