

function ensure() {

    var phonenum = $api.getStorage('username');
    if(!phonenum){
        api.alert({
            msg: '系统异常，请稍后再试！'
        }, function (ret, err) {
            //coding...
        });
        return;
    }

    var pwd = $api.byId('password').value;
    var pwd2 = $api.byId('verifypassword').value;

    if (pwd !== pwd2) {
        api.alert({
            msg: '两次密码不一致！'
        }, function (ret, err) {
            //coding...
        });
        return;
    }

    if (pwd.length < 6 || pwd.length > 20) {
        api.alert({
            msg: '密码长度6-20位！'
        }, function (ret, err) {
            //coding...
        });
        return;
    }

    var vercode = $api.getStorage('vercode');
    
    var checkAction = $api.byId('checkAction').value;
    var reqAction = 'password_reset_login';
    if(checkAction =='register'){
        reqAction = 'register_login';
    }

    api.showProgress({
        title: '提交中...',
        modal: false
    });

    
    var bodyParam = {
        action: reqAction,
        req: {
            "phone": phonenum, 
            "password": MD5(pwd),
            "code": vercode,
            "appid": api.appId,
            "appname": api.appName,
            "appversion": api.appVersion,
            "systemtype": api.systemType,
            "systemversion": api.systemVersion,
            "version": api.version,
            "deviceid": api.deviceId,
            "devicetoken": api.deviceToken,
            "devicemodel": api.deviceModel,
            "devicename": api.deviceName,
            "uimode": api.uiMode,
            "operator": api.operator,
            "connectiontype": api.connectionType
        }
    }

    console.log(api.frameName  + '> ensure req bodyParam:' + JSON.stringify(bodyParam) );


    // Post
    ajaxPost(bodyParam, function (ret, err) {

        // api.alert({
        //     msg: ret
        // });
        console.log(api.frameName  + '> ensure ret:' + JSON.stringify( ret) );

        if (ret && ret.state && ret.data) {
            
            // 密码设置成功，进入首页
            $api.setStorage('uid', phonenum);
            $api.setStorage('token', ret.data.token);
            var userinfo = ret.data;
            userinfo.sjh=phonenum;
            if(userinfo.txurl){
                userinfo.cachedTxUrl = userinfo.txurl;
            } else {
                userinfo.cachedTxUrl = '../image/userTitle.png';
            }
            $api.setStorage('userinfo',userinfo);
            $api.setStorage('usertxurl',userinfo.cachedTxUrl);
            
            api.execScript({
                name: 'root',
                script: 'init();'
            });

            setTimeout(function () {
                api.closeWin();
            }, 500);

        } else {

            if(ret && !ret.state){
                api.alert({
                    msg: ret.cljg
                });
            }

            if(err){
                api.alert({
                    msg: err.msg
                });
            }

        }

        api.hideProgress();
    })

}



// 校验两次密码是否一致
var elPwd=$api.byId('password');
var elVerPwd=$api.byId('verifypassword');
$api.addEvt(elVerPwd, 'keyup', function(){
    var elBtnRegSubmit=$api.byId('regSubmit');
    if($api.val(elVerPwd).length>=6 && $api.val(elVerPwd)==$api.val(elPwd)){
        $api.addCls(elBtnRegSubmit, 'aui-btn-info');
    } else {
        $api.removeCls(elBtnRegSubmit, 'aui-btn-info');
    }
});



apiready = function(){
    api.parseTapmode();

    if(api.pageParam){
        //alert($api.jsonToStr(api.pageParam));

        if(api.pageParam.checkAction){
            $api.byId('checkAction').value = api.pageParam.checkAction;
        } else {
            alert('调用手机号码验证异常！');
        }

        // if(api.pageParam.txtTitle){
        //     $api.text($api.byId('txtCheckTitle'), api.pageParam.txtTitle);
        // }

        // if(api.pageParam.btnText){
        //     $api.text($api.byId('regSubmit'), api.pageParam.btnText);
        // }
    }

    var phonenum = $api.getStorage('username');
    if(phonenum){
        $api.text($api.byId('phonenum'), phonenum);
    }

    $api.byId('password').focus();

}
