var Communication = (function () {
    function Communication() {
    }
    Communication.ret_$LI$ = function () { if (Communication.ret == null)
        Communication.ret = [-1]; return Communication.ret; };
    ;
    Communication.KEY_$LI$ = function () { if (Communication.KEY == null)
        Communication.KEY = [-1992689996, 908635233, -730654905, 1491504540]; return Communication.KEY; };
    ;

    Communication.sendData = function (msg) {
        var L2_length = msg.length;
        var data = new Array(L2_length + Communication.L1_HEAD_LEN);
        data[0] = ((Communication.magic | 0));
        data[1] = (((L2_length & 255) | 0));
        data[2] = (((CRC_16.getCRC(msg, 0) >> 8 & 255) | 0));
        data[3] = (((CRC_16.getCRC(msg, 0) & 255) | 0));
        ///////java.lang.System.arraycopy(msg, 0, data, 4, L2_length);
        Array.prototype.splice.apply(data, [4,L2_length].concat(msg));
        return data;
    };
    Communication.s_received_buffer_$LI$ = function () { if (Communication.s_received_buffer == null)
        Communication.s_received_buffer = new Array(256); return Communication.s_received_buffer; };
    ;
    Communication.l1_reset = function () {
        Communication.received_content_length = 0;
        Communication.receive_state = 0;
    };
    Communication.L1_receive_data = function (data) {
        var length = data.length;
        switch ((Communication.receive_state)) {
            case 0:
                if (data[0] !== 0xab) {//////alert(data[0]);
                }
                else {
                    Communication.received_content_length = 0;
                    //////java.lang.System.arraycopy(data, 0, Communication.s_received_buffer_$LI$(), Communication.received_content_length, length);
                    Array.prototype.splice.apply(Communication.s_received_buffer, [Communication.received_content_length,length].concat(data)); 
                    Communication.received_content_length = length;//////alert('received_buffer len : ' + data.length + ' . s_buf: ' + Communication.s_received_buffer);
                    var tmp = Communication.s_received_buffer[1] & 255;
                    Communication.length_to_receive = tmp + 4;
                    Communication.length_to_receive -= length;
                    if (true) {//// TODO ////if (Communication.length_to_receive <= 0) {
                        var L2_data = Communication.L1_reslove_Date(Communication.s_received_buffer, Communication.received_content_length);
                        Communication.received_content_length = 0;
                        Communication.receive_state = 0;
                        return L2_data;
                    }
                    Communication.receive_state = 1;
                }
                break;
            case 1:
                //////java.lang.System.arraycopy(data, 0, Communication.s_received_buffer_$LI$(), Communication.received_content_length, length);
                Array.prototype.splice.apply(Communication.s_received_buffer, [Communication.received_content_length,length].concat(data)); 
                Communication.received_content_length += length;
                Communication.length_to_receive -= length;
                if (Communication.length_to_receive <= 0) {
                    var L2_data = Communication.L1_reslove_Date(Communication.s_received_buffer_$LI$(), Communication.received_content_length);
                    Communication.received_content_length = 0;
                    Communication.receive_state = 0;
                    return L2_data;
                }
                break;
        }
        return null;
    };
    Communication.L1_reslove_Date = function (data, length) {
        var L2_en_data = new Array(length - Communication.L1_HEAD_LEN);
        //////java.lang.System.arraycopy(data, Communication.L1_HEAD_LEN, L2_en_data, 0, length - Communication.L1_HEAD_LEN);
        L2_en_data = data.slice(Communication.L1_HEAD_LEN, length);
        var L2_de_data = XXtea.decrypt(L2_en_data, XXtea.toByteArray(Communication.KEY_$LI$(), false));console.log("recv raw data(" + L2_de_data.length + "): " + XXtea.byteToHex(L2_de_data));
        var crc_len = Communication.L1_HEAD_LEN - 2;
        if ((data[crc_len] === ((CRC_16.getCRC(L2_en_data, 0) >> 8 & 255) | 0)) && (data[(crc_len + 1)] === ((CRC_16.getCRC(L2_en_data, 0) & 255) | 0))) {
            if (L2_de_data[0] === ((Communication.native_seq_id & 255) | 0)) {//////alert('ok');
                var ret_data = new Array(L2_de_data.length - 1);
                //////java.lang.System.arraycopy(L2_de_data, 1, ret_data, 0, L2_de_data.length - 1);
                ret_data = L2_de_data.slice(1, L2_de_data.length);
                return ret_data;
            }
            return Communication.ret_$LI$();
        }
        return Communication.ret_$LI$();
    };
    Communication.getSendData = function (cmd, userc, data) {
        if (data == null) {
            return null;
        }
        var data_tail_len = 4 - (data.length + Communication.L2_HEAD_LEN) % 4;
        var head_len = Communication.L2_HEAD_LEN + data.length + data_tail_len;
        if (head_len < 8) {
            data_tail_len += 8 - head_len;
            head_len = 8;
        }
        var head = new Array();//////(head_len);
        Communication.native_seq_id = Communication.seq;
        head[0] = (((Communication.seq++ & 255) | 0));
        head[1] = (((cmd & 255) | 0));
        head[2] = (((userc & 255) | 0));
        //////java.lang.System.arraycopy(data, 0, head, 3, data.length);
        //////head.splice(3, data.length, data);	// TODO : data.length = 1 时才能用
        head = head.concat(data);
        if (data_tail_len !== 0) {
            var tail = [(Communication.TAIL | 0)];
            for (var i = 0; i < data_tail_len; i++) {
                //////java.lang.System.arraycopy(tail, 0, head, Communication.L2_HEAD_LEN + data.length + i, tail.length);
                head.push(tail);
            }
        }//alert("head="+head);
        console.log("raw send data(" + head.length + "): " + XXtea.byteToHex(head));
        var key = XXtea.toByteArray(Communication.KEY_$LI$(), false);
        return Communication.encode(head);
    };
    Communication.encode = function (data) {
        var key = XXtea.toByteArray(Communication.KEY_$LI$(), false);
        return Communication.sendData(XXtea.encrypt(data, key));
    };
    Communication.handlerRandom = function (data, key_str, b_user) {
        if ((data == null) || (data.length <= 0) || (key_str == null) || (key_str.length <= 0) || (b_user == null) || (b_user.length <= 0)) {
            return null;
        }
        var open_data = new Array(4);
        var randomdata = new Array(12);
        var key = XXtea.getKey(key_str);
        XXtea.ntohl(key, key.length);
        //////java.lang.System.arraycopy(data, 1, randomdata, 0, 12);
        randomdata = data.slice(1, 1+12);
        var random = XXtea.decrypt(randomdata, key);
        var en_data = XXtea.encrypt(random, XXtea.toByteArray(Communication.KEY_$LI$(), false));
        //////java.lang.System.arraycopy(en_data, 8, open_data, 0, 4);
        open_data = en_data.slice(8, 8+4);
        var send = new Array(b_user.length + 4);
        //////java.lang.System.arraycopy(b_user, 0, send, 0, b_user.length);
        //////java.lang.System.arraycopy(open_data, 0, send, b_user.length, 4);
        send = b_user.concat(open_data);
        return send;
    };
    Communication.readCardnoTobyteArray = function (data) {
        if ((data == null) || (data.length <= 0)) {
            return null;
        }
        var long_data = 0;
        try {
            long_data = Number(data);	////////// javaemul.internal.LongHelper.parseLong(data.trim());
        }
        catch (e) {
            return null;
        }
        ;
        var byte_data = new Array(5);
        for (var i = 0; i < 4; i++) {
            byte_data[(5 - i - 1 - 1)] = ((((long_data >> 8 * i & 255) | 0) | 0));
        }
        return byte_data;
    };
    Communication.phoneTobyteArray$java_lang_String = function (data) {
        if ((data == null) || (data.length <= 0)) {
            return null;
        }
        var long_data = 0;
        try {
            long_data = Number(data);	////////// javaemul.internal.LongHelper.parseLong(data.trim());
        }
        catch (e) {
            return null;
        }
        ;
        var byte_data = new Array(5);
        for (var i = 0; i < 5; i++) {
            byte_data[(5 - i - 1)] = ((((long_data / Math.pow(2, 8 * i) & 255) | 0) | 0));
        }
        return byte_data;
    };
    Communication.phoneTobyteArray = function (data, res) {
        if (((typeof data === 'string') || data === null) && ((typeof res === 'number') || res === null)) {
            var __args = Array.prototype.slice.call(arguments);
            return (function () {
                if ((data == null) || (data.length <= 0)) {
                    return null;
                }
                var long_data = 0;
                try {
                    long_data = Number(data);	////////// javaemul.internal.LongHelper.parseLong(data.trim());
                }
                catch (e) {
                    return null;
                }
                ;
                var byte_data = new Array(5);
                for (var i = 0; i < 5; i++) {
                    byte_data[(5 - i - 1)] = ((((long_data / Math.pow(2, 8 * i) & 255) | 0) | 0));
                }
                byte_data[0] = (((byte_data[0] + (res << 5)) | 0));
                return byte_data;
            })();
        }
        else if (((typeof data === 'string') || data === null) && res === undefined) {
            return Communication.phoneTobyteArray$java_lang_String(data);
        }
        else
            throw new Error('invalid overload');
    };
    Communication.handleStringPwd = function (data) {
        if ((data == null) || (data.length <= 0)) {
            return null;
        }
        var long_data = 0;
        try {
            long_data = Number(data); /////////// javaemul.internal.LongHelper.parseLong(data.trim());
        }
        catch (e) {
            return null;
        }
        ;
        var byte_data = new Array(3);
        for (var i = 0; i < 3; i++) {
            byte_data[i] = ((((long_data >> 8 * (3 - i - 1) & 255) | 0) | 0));
        }
        return byte_data;
    };
    Communication.handleStringTime = function (strTime) {
        if ((strTime == null) || (strTime.length !== 14)) {
            return null;
        }
        var byte_data = new Array(7);
        for (var i = 0; i < 7; i++) {
            byte_data[i] = javaemul.internal.ByteHelper.valueOf(strTime.substring(i * 2, i * 2 + 2)).byteValue();
        }
        return byte_data;
    };
    Communication.HexString2byteArray = function (hexString) {
        if ((hexString == null) || (hexString.length === 0)) {
            return null;
        }
        var len = hexString.length;
        if (len % 2 !== 0) {
            hexString = "0" + hexString;
            len++;
        }
        var data = new Array((len / 2 | 0));
        for (var i = 0; i < (len / 2 | 0); i++) {
            var tmp = parseInt(hexString.substring(i * 2, i * 2 + 2), 16); 	//////javaemul.internal.LongHelper.parseLong(hexString.substring(i * 2, i * 2 + 2), 16);
            if ((tmp > 0) || (tmp < 256)) {
                data[i] = (((tmp | 0) | 0));
            }
            else {
                throw new java.lang.NumberFormatException("Value out of range for byte,Please check String");
            }
        }
        return data;
    };
    Communication.byteToHex = function (m, length) {
        if (((m != null && m instanceof Array) || m === null) && ((typeof length === 'number') || length === null)) {
            var __args = Array.prototype.slice.call(arguments);
            return (function () {
                var x = "";
                for (var i = 0; i < length; i++) {
                    x = x + " " + javaemul.internal.StringHelper.format("%02x", javaemul.internal.ByteHelper.valueOf(m[i]));// TODO 尚未改造完毕
                }
                return x;
            })();
        }
        else if (((m != null && m instanceof Array) || m === null) && length === undefined) {
            return Communication.byteToHex$byte_A(m);
        }
        else
            throw new Error('invalid overload');
    };
    Communication.byteToHex$byte_A = function (m) {
        if (m == null) {
            return null;
        }
        return Communication.byteToHex(m, m.length);
    };
    Communication.byteToHexString = function (data, data_len) {
        if (data == null) {
            return null;
        }
        var x = "";
        for (var i = 0; i < data_len; i++) {
            x = x + javaemul.internal.StringHelper.format("%02x", javaemul.internal.ByteHelper.valueOf(data[i]));// TODO 尚未改造完毕
        }
        return x;
    };
    Communication.magic = 171;
    Communication.seq = 0;
    Communication.L1_HEAD_LEN = 4;
    Communication.L2_HEAD_LEN = 3;
    Communication.TAIL = 255;
    Communication.L2_CMD_SETTING = 2;
    Communication.L2_CMD_CONTROL = 3;
    Communication.L2_CMD_GET = 4;
    Communication.L2_CMD_UPDATE = 5;
    Communication.L2_CMD_TEST = 6;
    Communication.L2_USER_RAND = 1;
    Communication.L2_USER_LOGIN = 2;
    Communication.native_seq_id = 0;
    Communication.RESOLVE_STATE = 0;
    Communication.RAND_LEN = 4;
    Communication.WAIT_START = 0;
    Communication.WAIT_MESSAGE = 1;
    Communication.MESSAGE_RESOLVE = 2;
    Communication.receive_state = 0;
    Communication.received_content_length = 0;
    Communication.L1_HEADER_MAGIC = -85;
    Communication.L1_HEADER_SIZE = 4;
    Communication.L1_HEADER_MAGIC_POS = 0;
    Communication.L1_PAYLOAD_LENGTH_POS = 1;
    Communication.L1_HEADER_CRC16_HIGH_BYTE_POS = 2;
    Communication.L1_HEADER_CRC16_LOW_BYTE_POS = 3;
    Communication.L2_DATA_SEQ_ID_POS = 4;
    Communication.L2_DATA_CMD_POS = 5;
    Communication.L2_DATA_SUB_CMD_POS = 6;
    Communication.L2_DATA_VALUE_POS = 7;
    Communication.CARDNO_LEN = 5;
    Communication.ACCESS_CONTROLLOR_LEN = 5;
    Communication.PWD_LEN = 3;
    Communication.TIME_LEN = 7;
    return Communication;
}());
Communication["__class"] = "Communication";
Communication.s_received_buffer_$LI$();
Communication.KEY_$LI$();
Communication.ret_$LI$();
