﻿

apiready = function(){

    api.parseTapmode();

    _citydm = getData(_L_citydm);
    _citymc = getData(_L_citymc);
    _citylist = getData(_L_citylist);
    if(_citylist){
        _citylist = JSON.parse(_citylist);
    }
    
    console.log(' _citydm : ' + _citydm + ', _citymc : ' + _citymc);
    console.log(' _citylist : ' + JSON.stringify( _citylist) );

    locateSelect();
};


function locateSelect(){

    var contactData = [];

    if(_citylist && _citylist.length > 0 && _citydm){
        for( var idx in _citylist ){

            var contact = {
                dm: _citylist[idx].dm,
                name: _citylist[idx].jc,
                customerTypes: _citylist[idx].sf,
                cityinfo: _citylist[idx]
            };

            if(_citydm && _citydm == contact.dm){
                contact.name=contact.name + '(当前)';
            }

            contactData.push(contact);

        }

        // // 更改标题
        // api.execScript({
        //     name: 'locationSelect',
        //     script: 'changeCity("'+_citymc+'");'
        // });

    }


    var UIListCard = api.require('UIListCard');

    UIListCard.open({
                rect : {
                    x : 0,
                    y : 0,
                    w : api.frameWidth,
                    h : api.frameHeight
                },
                contacts : contactData,
                fixedOn : api.frameName
            }, function(ret) {
                if (ret) {
                    console.log(' UIListCard  ret : ' + JSON.stringify( ret) );

                    if(ret.eventType == 'click' && ret.contact  && ret.contact.dm && ret.contact.cityinfo){

                        if(_citydm != ret.contact.dm) {
                            saveCityInfo(ret.contact.cityinfo);

                            // 关闭当前窗口
                            setTimeout(function () {
                                api.execScript({
                                    name: 'locationSelect',
                                    frameName: 'locationSelect_frm',
                                    script: 'init();'
                                });
                            }, 10);
                        }


                        // 关闭当前窗口
                        setTimeout(function () {
                            api.execScript({
                                name: 'locationSelectCity',
                                script: 'closewin();'
                            });
                        }, 200);

                    }

                }
            });

}

