function delWord(el) {
    var input = $api.prev(el, '.txt');
    input.value = '';
}

function ensure() {
    var oldPwd = $api.byId('currentPwd').value;
    var newPwd = $api.byId('newPwd').value;
    var newPwd2 = $api.byId('newPwd2').value;

    if (!oldPwd) {
        api.alert({
            msg: '请输入当前密码！'
        });

        return;
    }

    if (!newPwd || newPwd.length<6) {
        api.alert({
            msg: '请输入6-20位新密码'
        });

        return;
    }

    if (newPwd !== newPwd2) {
        api.alert({
            msg: '确认密码与新密码不一致'
        });

        return;
    }


    if (oldPwd && newPwd && newPwd2 && newPwd === newPwd2) {

        var bodyParam = {
            action: "password_modify",
            req: {
                password: MD5(newPwd),
                old_password: MD5(oldPwd)
            }
        }

        api.showProgress({
            title: '修改中...',
            modal: false
        });

        // Post
        ajaxPost(bodyParam, function (ret, err) {

            // api.alert({
            //     msg: ret
            // });

            if (ret && ret.state) {

                api.alert({
                    msg: '修改成功'
                }, function (ret, err) {
                    api.closeWin();
                });

            } else {
                api.toast({msg: ret.cljg,location: 'middle'})
                if(err){
                    api.alert({
                        msg: err.msg
                    });
                }
            }

            api.hideProgress();
        })
    }
}

var inputWrap = $api.domAll('.input-wrap');
var i = 0, len = inputWrap.length;
for (i; i < len; i++) {
    var txt = $api.dom(inputWrap[i], '.txt');
    var del = $api.dom(inputWrap[i], '.del');
    (function (txt, del) {
        $api.addEvt(txt, 'focus', function () {
            if (txt.value) {
                $api.addCls(del, 'show');
            }
            $api.addCls(txt, 'light');
        });
        $api.addEvt(txt, 'blur', function () {
            $api.removeCls(del, 'show');
            $api.removeCls(txt, 'light');
        });
    })(txt, del);

}


apiready = function () {
    api.parseTapmode();
    
    var header = $api.byId('aui-header');
    $api.fixStatusBar(header);
}


function closewin(){
    api.closeWin();
}
