
apiready = function () {
    api.parseTapmode();

    init();
};


// 初始化，下载公告列表
function init() {

    var sssqinfo = getData('sssqinfo');
    if(sssqinfo){
        sssqinfo = JSON.parse(sssqinfo);

        console.log(api.frameName + ' init sssqinfo : ' + JSON.stringify(sssqinfo) );

        var wyxx = sssqinfo.xxWyxx;

        if(!wyxx){
            wyxx = {
                gsmc: '杭州憧联科技有限公司',
                logourl: '../image/clkj-logo.jpg',
                lxdh: '0571-86813701'
            };
        }

        if(wyxx && wyxx.lxdh ){
            if(wyxx.gscs){
                var wygscs = JSON.parse(wyxx.gscs);
                if(wygscs.lxdhmc){
                    wyxx.lxdhmc = wygscs.lxdhmc;
                }
            } 

            if(!wyxx.lxdhmc){
                wyxx.lxdhmc = '联系电话：';
            }
        } else {
            wyxx.lxdh = '0571-86813701';
        }

        if(wyxx && wyxx.lxdh2 ){
            if(wyxx.gscs){
                var wygscs = JSON.parse(wyxx.gscs);
                if(wygscs.lxdhmc2){
                    wyxx.lxdhmc2 = wygscs.lxdhmc2;
                }
            } 

            if(!wyxx.lxdhmc2){
                wyxx.lxdhmc3 = ' ';
            }
        } else {
            wyxx.lxdh2 = ' ';
            wyxx.lxdhmc2 = ' ';
        }

        if(wyxx && wyxx.lxdh3 ){
            if(wyxx.gscs){
                var wygscs = JSON.parse(wyxx.gscs);
                if(wygscs.lxdhmc3){
                    wyxx.lxdhmc3 = wygscs.lxdhmc3;
                }
            } 

            if(!wyxx.lxdhmc3){
                wyxx.lxdhmc3 = ' ';
            }
        } else {
            wyxx.lxdh3 = ' ';
            wyxx.lxdhmc3 = ' ';
        }

        if(wyxx && wyxx.lxdz ){
            if(wyxx.gscs){
                var wygscs = JSON.parse(wyxx.gscs);
                if(wygscs.lxdz){
                    wyxx.lxdzmc = wygscs.lxdzmc;
                }
            } 

            if(!wyxx.lxdzmc){
                wyxx.lxdzmc = '联系地址：';
            }
        } else {
            wyxx.lxdzmc = '联系地址：';
            wyxx.lxdz = wyxx.gsmc;
        }


        if(wyxx && !wyxx.logourl){
            wyxx.logourl = '../image/clkj-logo.jpg';
        }

        showWyxx(wyxx);
    } else {

        noBindHouse();

        setTimeout(function () {
            api.closeWin();
        }, 500);
    }

}


function showWyxx(wyxx){

    if(wyxx){
        console.log(api.frameName + ' showWyxx wyxx : ' + JSON.stringify(wyxx) );

        //渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
        content.innerHTML = tempFn(wyxx);
        // alert(content.innerHTML); 

        api.parseTapmode();
    }
}


function call(num){
    api.call({
        type: 'tel_prompt',
        number: num
    });
    event.preventDefault();
}


