function delWord(el) {
    var input = $api.prev(el, '.txt');
    input.value = '';
}

function openRegister() {
    api.execScript({
        name: 'userLogin',
        script: 'openRegister();'
    });
}

function openReset() {
    api.execScript({
        name: 'userLogin',
        script: 'openReset();'
    });
}

function openBindDev() {
    api.execScript({
        name: 'userLogin',
        script: 'openBindDev();'
    });
}

function ensure() {

    var username = $api.byId('username').value;
    if(username){
        // 保存登录名
        $api.setStorage('username', username);
    }

    var password = $api.byId('password').value;
    if(!password || password.length < 6){
        api.alert({
            msg: '请输入正确的密码！'
        }, function (ret, err) {
            //coding...
        });
        return;
    }

    var bodyParam = {
        action: "login",
        req: {
            "phone": username, 
            "password": MD5(password),
            "appid": api.appId,
            "appname": api.appName,
            "appversion": api.appVersion,
            "systemtype": api.systemType,
            "systemversion": api.systemVersion,
            "version": api.version,
            "deviceid": api.deviceId,
            "devicetoken": api.deviceToken,
            "devicemodel": api.deviceModel,
            "devicename": api.deviceName,
            "uimode": api.uiMode,
            "operator": api.operator,
            "connectiontype": api.connectionType
        }
    }
    console.log(api.frameName  + '> ensure req bodyParam:' + JSON.stringify(bodyParam) );

    api.showProgress({
        title: '正在登录...',
        modal: false
    });

    // Post
    ajaxPost(bodyParam, function (ret, err) {

        console.log(api.frameName  + '> ensure ret:' + JSON.stringify( ret) );

        // api.alert({
        //     msg: ret
        // }); 

        if (ret && ret.state && ret.data) {

            // 读取上次登录的用户id
            var lastuid=$api.getStorage('uid');

            $api.setStorage('token', ret.data.token);
            $api.setStorage('uid', username);
            var userinfo = ret.data;
            userinfo.sjh=username;
            if(userinfo.txurl){
                userinfo.cachedTxUrl = userinfo.txurl;
            } else {
                userinfo.cachedTxUrl = '../image/userTitle.png';
            }
            $api.setStorage('userinfo',userinfo);
            $api.setStorage('usertxurl',userinfo.cachedTxUrl);

            // 如果本次登陆的用户跟之前的不一样，则清除本地缓存
            if(lastuid && lastuid != username){
                removeData('sssqinfolist_timeout');
                removeData('sssq');
                removeData('citylist');
            }
            
            api.execScript({
                name: 'root',
                script: 'init();'
            });

            setTimeout(function () {
                api.closeWin();
            }, 200);

        } else {

            if(ret && !ret.state){
                // 未绑定设备,需要重新验证手机号码
                if(ret.clbz=='DEVICE_NOT_BIND'){

                    api.confirm({
                        title: '手机设备绑定提醒',
                        msg: '当前手机设备与上一次登录的不一致，需要重新验证手机号码，验证通过后，该帐号在原先设备登录将全部失效！',
                        buttons: ['开始验证', '取消']
                    }, function(ret, err) {
                        //alert($api.jsonToStr(ret));
                        //var index = ret.buttonIndex;

                        // 进入绑定设备页面
                        if(ret.buttonIndex==1){
                            openBindDev();
                        }
                    });


                } else {
                    api.alert({
                        msg: ret.cljg
                    });
                }
            }

            if(err){
                api.alert({
                    msg: err.msg
                });
            }
        }
        api.hideProgress();
    })
}


apiready = function () {
    api.parseTapmode();

    var username = $api.getStorage('username');
    if(username){
        // api.alert({
        //     msg: username
        // });

        $api.byId('username').value = username;
        //$api.byId('password').focus();
    } else {
        $api.byId('username').focus();
    }

    var usertxurl = $api.getStorage('usertxurl');
    if(usertxurl){
        // api.alert({
        //     msg: usertxurl
        // });

        $api.byId('txurl').src = usertxurl;
    }


};