
apiready = function () {
    api.parseTapmode();

    init();
};


// 初始化，下载公告列表
function init() {

    var dqsssq = getData('sssq');
    if(dqsssq){
        console.log(api.frameName + '> init sssq: ' + dqsssq);
        
        // 从服务端取当前用户可用的设备列表
        initSbxx(dqsssq,showSbxxList);

    } else {

        noBindHouse();

        setTimeout(function () {
            api.closeWin();
        }, 500);
    }

}



function showSbxxList(sbxxlist){

    if(sbxxlist){
        console.log(api.frameName + ' showSbxxList sbxxlist : ' + JSON.stringify(sbxxlist) );

        var keyboardsbxx = [];

        // 过滤设备列表，只取支持密码键盘的设备？
        if(sbxxlist && sbxxlist.length>0){
            for(var idx=0; idx < sbxxlist.length; idx++){
                if(sbxxlist[idx].keyboard && sbxxlist[idx].keyboard == '1'){
                    keyboardsbxx.push(sbxxlist[idx]);
                }
            }
        }

        //渲染页面
        var content = $api.byId('content');
        var tpl = $api.byId('template').text;
        var tempFn = doT.template(tpl);
        content.innerHTML = tempFn(keyboardsbxx);
        // alert(content.innerHTML); 

        api.parseTapmode();
    }
}


function openVisitAuthPass(devKey){
    console.log(api.frameName + ' getVisitorPassword devKey : ' + JSON.stringify(devKey)   );

    api.openWin({
        name: 'visitAuthPass',
        url: 'visitAuthPass.html',
        pageParam: {devKey: devKey}
    });

}


